import pygame
key_list = [
    (pygame.K_BACKSPACE, "BACKSPACE"),
    (pygame.K_TAB, "TAB"),
    (pygame.K_RETURN, "ENTER"),
    (pygame.K_SPACE, "SPACEBAR"),
    (pygame.K_COMMA, "COMMA"),
    (pygame.K_MINUS, "-"),
    (pygame.K_PERIOD, "PERIOD"),
    (pygame.K_SLASH, "/"),
    (pygame.K_0, "0"),
    (pygame.K_1, "1"),
    (pygame.K_2, "2"),
    (pygame.K_3, "3"),
    (pygame.K_4, "4"),
    (pygame.K_5, "5"),
    (pygame.K_6, "6"),
    (pygame.K_7, "7"),
    (pygame.K_8, "8"),
    (pygame.K_9, "9"),
    (pygame.K_SEMICOLON, ";"),
    (pygame.K_EQUALS, "="),
    (pygame.K_LEFTBRACKET, "["),
    (pygame.K_RIGHTBRACKET, "]"),
    (pygame.K_BACKSLASH, "BACKSLASH"),
    (pygame.K_BACKQUOTE, "`"),
    (pygame.K_a, "A"),
    (pygame.K_b, "B"),
    (pygame.K_c, "C"),
    (pygame.K_d, "D"),
    (pygame.K_e, "E"),
    (pygame.K_f, "F"),
    (pygame.K_g, "G"),
    (pygame.K_h, "H"),
    (pygame.K_i, "I"),
    (pygame.K_j, "J"),
    (pygame.K_k, "K"),
    (pygame.K_l, "L"),
    (pygame.K_m, "M"),
    (pygame.K_n, "N"),
    (pygame.K_o, "O"),
    (pygame.K_p, "P"),
    (pygame.K_q, "Q"),
    (pygame.K_r, "R"),
    (pygame.K_s, "S"),
    (pygame.K_t, "T"),
    (pygame.K_u, "U"),
    (pygame.K_v, "V"),
    (pygame.K_w, "W"),
    (pygame.K_x, "X"),
    (pygame.K_y, "Y"),
    (pygame.K_z, "Z"),
    (pygame.K_DELETE, "DELETE"),
    (pygame.K_KP0, "KEYPAD 0"),
    (pygame.K_KP1, "KEYPAD 1"),
    (pygame.K_KP2, "KEYPAD 2"),
    (pygame.K_KP3, "KEYPAD 3"),
    (pygame.K_KP4, "KEYPAD 4"),
    (pygame.K_KP5, "KEYPAD 5"),
    (pygame.K_KP6, "KEYPAD 6"),
    (pygame.K_KP7, "KEYPAD 7"),
    (pygame.K_KP8, "KEYPAD 8"),
    (pygame.K_KP9, "KEYPAD 9"),
    (pygame.K_KP_MULTIPLY, "KP MULT"),
    (pygame.K_KP_DIVIDE, "KP DIV"),
    (pygame.K_KP_MINUS, "KP MINUS"),
    (pygame.K_KP_PLUS, "KP PLUS"),
    (pygame.K_KP_ENTER, "KP ENTER"),
    (pygame.K_UP, "UP"),
    (pygame.K_DOWN, "DOWN"),
    (pygame.K_LEFT, "LEFT"),
    (pygame.K_RIGHT, "RIGHT"),
    (pygame.K_HOME, "HOME"),
    (pygame.K_END, "END"),
    (pygame.K_PAGEUP, "PAGEUP"),
    (pygame.K_PAGEDOWN, "PAGEDOWN"),
    (pygame.K_F1, "F1"),
    (pygame.K_F2, "F2"),
    (pygame.K_F3, "F3"),
    (pygame.K_F4, "F4"),
    (pygame.K_F5, "F5"),
    (pygame.K_F6, "F6"),
    (pygame.K_F7, "F7"),
    (pygame.K_F8, "F8"),
    (pygame.K_F9, "F9"),
    (pygame.K_F10, "F10"),
    (pygame.K_F11, "F11"),
    (pygame.K_F12, "F12"),
    (pygame.K_F13, "F13"),
    (pygame.K_F14, "F14"),
    (pygame.K_F15, "F15"),
    (pygame.K_CAPSLOCK, "CAPSLOCK"),
    (pygame.K_SCROLLOCK, "SCROLLOCK"),
    (pygame.K_RSHIFT, "RIGHT SHIFT"),
    (pygame.K_LSHIFT, "LEFT SHIFT"),
    (pygame.K_RCTRL, "RIGHT CTRL"),
    (pygame.K_LCTRL, "LEFT CTRL"),
    (pygame.K_RALT, "RIGHT ALT"),
    (pygame.K_LALT, "LEFT ALT")
]

key_decoder = [
    (pygame.K_BACKSPACE, 8),
    (pygame.K_TAB, 9),
    (pygame.K_RETURN, 13),
    (pygame.K_SPACE, 32),
    (pygame.K_COMMA, 44),
    (pygame.K_MINUS, 45),
    (pygame.K_PERIOD, 46),
    (pygame.K_SLASH, 47),
    (pygame.K_0, 48),
    (pygame.K_1, 49),
    (pygame.K_2, 50),
    (pygame.K_3, 51),
    (pygame.K_4, 52),
    (pygame.K_5, 53),
    (pygame.K_6, 54),
    (pygame.K_7, 55),
    (pygame.K_8, 56),
    (pygame.K_9, 57),
    (pygame.K_SEMICOLON, 59),
    (pygame.K_EQUALS, 61),
    (pygame.K_LEFTBRACKET, 91),
    (pygame.K_RIGHTBRACKET, 93),
    (pygame.K_BACKSLASH, 92),
    (pygame.K_BACKQUOTE, 96),
    (pygame.K_a, 97),
    (pygame.K_b, 98),
    (pygame.K_c, 99),
    (pygame.K_d, 100),
    (pygame.K_e, 101),
    (pygame.K_f, 102),
    (pygame.K_g, 103),
    (pygame.K_h, 104),
    (pygame.K_i, 105),
    (pygame.K_j, 106),
    (pygame.K_k, 107),
    (pygame.K_l, 108),
    (pygame.K_m, 109),
    (pygame.K_n, 110),
    (pygame.K_o, 111),
    (pygame.K_p, 112),
    (pygame.K_q, 113),
    (pygame.K_r, 114),
    (pygame.K_s, 115),
    (pygame.K_t, 116),
    (pygame.K_u, 117),
    (pygame.K_v, 118),
    (pygame.K_w, 119),
    (pygame.K_x, 120),
    (pygame.K_y, 121),
    (pygame.K_z, 122),
    (pygame.K_DELETE, 127),
    (pygame.K_KP0, 256),
    (pygame.K_KP1, 257),
    (pygame.K_KP2, 258),
    (pygame.K_KP3, 259),
    (pygame.K_KP4, 260),
    (pygame.K_KP5, 261),
    (pygame.K_KP6, 262),
    (pygame.K_KP7, 263),
    (pygame.K_KP8, 264),
    (pygame.K_KP9, 265),
    (pygame.K_KP_MULTIPLY, 268),
    (pygame.K_KP_DIVIDE, 267),
    (pygame.K_KP_MINUS, 269),
    (pygame.K_KP_PLUS, 270),
    (pygame.K_KP_ENTER, 271),
    (pygame.K_UP, 273),
    (pygame.K_DOWN, 274),
    (pygame.K_LEFT, 276),
    (pygame.K_RIGHT, 275),
    (pygame.K_HOME, 278),
    (pygame.K_END, 279),
    (pygame.K_PAGEUP, 280),
    (pygame.K_PAGEDOWN, 281),
    (pygame.K_F1, 282),
    (pygame.K_F2, 283),
    (pygame.K_F3, 284),
    (pygame.K_F4, 285),
    (pygame.K_F5, 286),
    (pygame.K_F6, 287),
    (pygame.K_F7, 288),
    (pygame.K_F8, 289),
    (pygame.K_F9, 290),
    (pygame.K_F10, 291),
    (pygame.K_F11, 292),
    (pygame.K_F12, 293),
    (pygame.K_F13, 294),
    (pygame.K_F14, 295),
    (pygame.K_F15, 296),
    (pygame.K_CAPSLOCK, 301),
    (pygame.K_SCROLLOCK, 302),
    (pygame.K_RSHIFT, 303),
    (pygame.K_LSHIFT, 304),
    (pygame.K_RCTRL, 305),
    (pygame.K_LCTRL, 306),
    (pygame.K_RALT, 307),
    (pygame.K_LALT, 308)
]